
AppTitle "SoundPlayTest"

Include "\Dev\Blitz\Lib\Input.Def.bb"
Include "\Dev\Blitz\Lib\String.Lib.BB"
Include "\Dev\Blitz\Lib\TimerSystem 4b.BB"

Const fadetime = 2000

Graphics 800,600 , 0,2
Graphics 640,480 , 0,3
ClsColor 0,64,128
Cls
Color 224,240,255
SetFont LoadFont( "Small Fonts" , 15 )
SetBuffer BackBuffer()

Local cmd$ = CommandLine()
If cmd = ""
    RuntimeError "Usage:"+Chr(13)+"SoundPlayTest D:\Music\Track1.MP3"+Chr(13)+"Append '/' and space separated options: fadein fadeout"
End If
Local split = Instr( cmd , "/" )
Local fadein = False
Local fadeout = False
Local fadedir = 0
If split
    String_FillParameters Mid( cmd , split+1 )
    Local which
    For which = 1 To String_Parameters[0]
        Select Lower( String_Parameters[which] )
            Case "fadein"
                fadein = True
                fadedir = 1
            Case "fadeout"
                fadeout = True
        End Select
    Next
    cmd = Left( cmd , split-1 )
End If
Local file$ = String_CutQuotes( String_Trim( cmd ) )
If FileType( file ) <> 1
    RuntimeError "File not found:"+Chr(13)+file
End If
Local sample = LoadSound( file )
If Not sample
    RuntimeError "Unable to load audio file:"+Chr(13)+file
End If
LoopSound sample
MilliSecs = MilliSecs()
Local chan = PlaySound( sample )
If fadein
    Local fading = True
    ChannelVolume chan , 0
End If
Local fadetimer = NewTimer( fadetime )
Local update = True

; force drawing to be enabled (blitz bug?)
Plot 0,0

Local exitloop = False
Local vol# = 0
Repeat
    MilliSecs = MilliSecs()
    If fading
        Select fadedir
            Case 1
                If TimerDone( fadetimer )
                    ChannelVolume chan , 1
                    fading = False
                    ;update = True
                Else
                    vol = TimerDelta( fadetimer )
                    ChannelVolume chan , vol
                    Text 10,30 , String( "|" , 10*vol )
                    Text 10,40 , Int( vol*100 )+"%"
                    update = True
                End If
            Case -1
                If TimerDone( fadetimer )
                    ChannelVolume chan , 0
                    fading = False
                    ;update = True
                    exitloop = True
                Else
                    vol = 1 - TimerDelta( fadetimer )
                    ChannelVolume chan , vol
                    Text 10,30 , String( "|" , 10*vol )
                    Text 10,40 , Int( vol*100 )+"%"
                    update = True
                End If
        End Select
    End If
    If KeyHit( Key_ESC )
        If Not fading
            If fadeout
                fading = True
                fadedir = -1
                ResetTimer fadetimer
            Else
                exitloop = True
            End If
        End If
    End If
    If update
        update = False
        Text 10,10 , file
        Flip
        Cls
    End If
    Delay 25
Until exitloop
If fadeout
    Delay 250
End If
End

;~IDEal Editor Parameters:
;~L#C:\Documents and Settings\T-C\Desktop\wayout1a-part1 rec 23 dec 2010.q5.ogg / fadein fadeout
;~C#Blitz3D1105